using System;
using Windows.System;
using System.Threading.Tasks;

using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Documents;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region   - ExecuteCommand

    /// <summary>
    ///  
    /// </summary>
    public DelegateCommand<object> ExecuteCommand { get; private set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ExecuteCommand = new DelegateCommand<object>(Execute);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region   ϱ (񵿱) - ExecuteWebBrowserAsync(url)

    /// <summary>
    ///   ϱ (񵿱)
    /// </summary>
    /// <param name="url">URL</param>
    /// <returns>½ũ</returns>
    private async Task ExecuteWebBrowserAsync(string url)
    {
        Uri uri = new Uri(url);

        await Launcher.LaunchUriAsync(uri);
    }

    #endregion
    #region ϱ - Execute(source)

    /// <summary>
    /// ϱ
    /// </summary>
    /// <param name="source">ҽ</param>
    private async void Execute(object source)
    {
        Hyperlink hyperlink = source as Hyperlink;

        string url = (hyperlink.Inlines[0] as Run).Text;

        await ExecuteWebBrowserAsync(url);
    }

    #endregion
}